Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2409 by niro, Tue Jan 7 13:27:16 2014 UTC revision 2499 by niro, Wed Jan 8 13:19:29 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
15    
# Line 27  for inc in %SYSCONFDIR%/installer.conf \ Line 28  for inc in %SYSCONFDIR%/installer.conf \
28   ${INSTALLER_LIBDIR}/functions/common.sh \   ${INSTALLER_LIBDIR}/functions/common.sh \
29   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
30   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
31     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
32     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
33   ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh   ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
34  do  do
35   if [ -e ${inc} ]   if [ -e ${inc} ]
# Line 68  SPECIALDEVICE="" Line 71  SPECIALDEVICE=""
71  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
72  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
73    
74  #################################################  
75  #  DIALOG BOXEN #  ### helper scripts ###
 #################################################  
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 84  trap_exit() Line 86  trap_exit()
86   exit 1   exit 1
87  }  }
88    
89  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
 }  
   
 dialog_setup_system_menu()  
 {  
  local i  
   
  i=$(dialog \  
  --backtitle "${TITLE}" \  
  --title "[ Festplatten Partitionierung ]" \  
  --cancel-label "Abbrechen" \  
  --ok-label "Weiter" \  
  --stdout \  
  --colors \  
  --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \  
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case "${i}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local i  
  local hwtmp  
   
  if [ -x $(type -P mktemp) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
   
  run_hardware_detection_disks  
   
  echo "dialog \\"  > ${hwtmp}  
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  done  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " CDROM Laufwerke:\n \\" >> ${hwtmp}  
  for i in ${ALL_CDROMS}  
  do  
  echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  done  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}  
  fi  
   
  echo " \" 14 70" >> ${hwtmp}  
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manuell  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
 run_hardware_detection_disks()  
 {  
  local bootdev  
   
  # all disks but exclude ramdisks  
  export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')  
  # remove the boot device from ALL_DISKS if it was an usbstick  
  if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]  
  then  
  bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"  
  export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")  
  fi  
  export ALL_CDROMS="$(get_hwinfo cdrom)"  
 }  
   
 dialog_setup_hdd_create_partitions()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
 }  
   
 dialog_install_meter()  
90  {  {
91   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
92   do   do
# Line 358  dialog_install_meter() Line 99  dialog_install_meter()
99   return 0   return 0
100  }  }
101    
102    mount_rootfs()
 dialog_install_bootsector()  
103  {  {
104   dialog \   local retval
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
105    
106  dialog_install_successful()   if is_mounted --location "${INSTALLROOT}"
107  {   then
108   dialog \   echo $"${INSTALLROOT} already mounted" >&2
109   --backtitle "${TITLE}" \   else
110   --colors \   mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
111   --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81   fi
112     [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
113  }  }
114    
115  dialog_install_failure()  umount_rootfs()
116  {  {
117   dialog \   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
118   --backtitle "${TITLE}" \   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
119  }  }
120    
121  dialog_main()  install_do_reboot()
122  {  {
123   METHOD=0   reboot
   
  while [[ ${METHOD} -le 2 ]]  
  do  
  METHOD=$(dialog \  
  --backtitle "${TITLE}" \  
  --no-cancel \  
  --ok-label "Weiter" \  
  --stdout \  
  --menu "Konfiguration" 14 70 5 \  
  "1" "AutoSta_LX installieren" \  
  "2" "Uebersicht gefundener Laufwerke" \  
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case ${METHOD} in  
  "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
124  }  }
125    
 #################################################  
 # Install Komandos #  
 #################################################  
126  run_hardware_detection()  run_hardware_detection()
127  {  {
128   local hwinfo   local hwinfo
129    
130   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
131    
132   # check for special devices/clients:   ## check for special devices/clients:
133   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
134   local removable=0   #local removable=0
135   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
136   then   #then
137   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
138   do   #do
139   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
140   then   #then
141   removable=1   #removable=1
142   fi   #fi
143   done   #done
144     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
145   # only add this for grub legacy, grub2 detect these settings on its own  
146   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
147   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
148   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
149   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
150   export SPECIALDEVICE="zotac_nvidia"   #then
151   else   #export SPECIALDEVICE="zotac_nvidia"
152   export SPECIALDEVICE="zotac_intel"   #else
153   fi   #export SPECIALDEVICE="zotac_intel"
154   fi   #fi
155     #fi
156    
157   # check for special devices/clients:   # check for special devices/clients:
158   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 474  run_hardware_detection() Line 181  run_hardware_detection()
181   fi   fi
182  }  }
183    
184  hdd_size_below_256mb()  run_hardware_detection_disks()
185  {  {
186   local hdd="$1"   local bootdev
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
187    
188   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # all disks but exclude ramdisks
189   if [[ ${size} -le 257000000 ]]   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
190     # remove the boot device from ALL_DISKS if it was an usbstick
191     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
192   then   then
193   retval="0"   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
194   else   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  retval="1"  
195   fi   fi
196     export ALL_CDROMS="$(get_hwinfo cdrom)"
  return "${retval}"  
197  }  }
198    
199  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
200  {  {
201   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
202    
203     # sanity check - should not happen
204     if is_mounted --device "${ROOTHDD}"
205     then
206     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
207     umount "${ROOTHDD}"
208     fi
209    
210   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
211   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
212   then   then
213   if hdd_size_below_256mb ${HDD}   if device_minimum_size "${HDD}" 256
214   then   then
215   FDISKPARTIONBELOW256MB=1   FDISKPARTIONBELOW256MB=1
216   else   else
# Line 554  EOF Line 265  EOF
265   fi   fi
266  }  }
267    
268  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
269  {  {
270   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
271     SWAPHDD=""
272   ## hdds partitionieren manuell   BOOTHDD=""
273   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
274  }  }
275    
276  setup_hdd_format()  setup_hdd_format()
277  {  {
278   mke2fs -j -q ${ROOTHDD} || dialog_die   # sanity check - should not happen
279  }   if is_mounted --device "${ROOTHDD}"
280     then
281     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
282     umount "${ROOTHDD}"
283     fi
284    
285  install_mount_rootfs()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
286  }  }
287    
288  install_system_image()  install_system_image()
289  {  {
290     pushd ${INSTALLROOT} > /dev/null
291   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
292     popd > /dev/null
293  }  }
294    
295  install_bootsector_chroot()  install_system_settings()
296  {  {
297   local my_roothdd   local CONFIG
  local grubconf=${INSTALLROOT}/boot/grub/grub.conf  
  local grub2conf=/boot/grub/grub.cfg  
298    
299   # check for grub2   # write fstab
300   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   CONFIG="${INSTALLROOT}/etc/fstab"
301   then   clearconfig
302   # needed by grub-mkconfig on the first run   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
303   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
304   then   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die  
  fi  
   
  # set kernelopts  
  if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]  
  then  
  sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  else  
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
305    
306   # grub-legacy   # install network config skeleton
307   else   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
308   ### grubconf schreiben   clearconfig
309   source ${INSTALLROOT}/boot/kernelversion   addconfig 'ONBOOT="yes"'
310     addconfig 'NETWORKING="dhcp"'
311    
312   #for alx only   # intel framebuffer quirk
313   if [ -e ${INSTALLROOT}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
314     then
315     if [ -e /proc/fb ]
316   then   then
317   OLD_ALXVER="${ALXVER}"   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
318   source ${INSTALLROOT}/etc/alx_version   then
319   KRNVER="ALX-${ALXVER}"   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
320   ALXVER="${OLD_ALXVER}"   if [[ ${fbdev} != 0 ]]
321     then
322     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
323     fi
324     fi
325   fi   fi
326     fi
327    }
328    
  [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  
  [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
329    
330   # uuid support  ### installer dialogs ###
  if is_uuid_supported  
  then  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
  else  
  my_roothdd="${ROOTHDD}"  
  fi  
331    
332   : > ${grubconf} || dialog_die  dialog_die()
333   echo "default 0" >> ${grubconf} || dialog_die  {
334   echo "timeout 3" >> ${grubconf} || dialog_die   ERROR="$1"
335   # using current root password   RETVAL="$?"
336   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die   dialog_install_failure
337     exit 1
338   echo  >> ${grubconf} || dialog_die  }
  echo "# normal boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER}" >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
   
  echo >> ${grubconf} || dialog_die  
  echo "# admin boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die  
  echo "lock"  >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
339    
340   echo >> ${grubconf} || dialog_die  dialog_warning()
341   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die  {
342   echo "lock"  >> ${grubconf} || dialog_die   local retval
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
343    
344   # bootsector schreiben chrooted schreiben (lfs/magellan)   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
345   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   retval=$?
346  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   if [[ ${retval} -eq 1 ]]
347  root (hd0,0)   then
348  setup (hd0)   clear
349  quit   echo $"The process was aborted."
350  EOF   exit 1
 exit 0  
 CHROOTEOF  
351   fi   fi
352    }
353    
  ## enter chroot  
  mount -t proc proc ${INSTALLROOT}/proc  
  mount -t sysfs sysfs ${INSTALLROOT}/sys  
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
 install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
354    
355   if [[ ${FORMFACTOR} = laptop ]]  ### installer tasks ###
356    
357    task_setup_system_menu()
358    {
359     local mode
360     local retval
361    
362     mode="$(dialog_setup_system_menu)"
363     retval=$?
364     [[ ${retval} -eq 1 ]] && return 1
365     if [[ ${retval} -eq 0 ]]
366   then   then
367   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   case "${mode}" in
368     "1") run_install_auto ;;
369     "2") run_install_normal ;;
370     "") task_setup_system_menu;;
371     esac
372   fi   fi
373    }
374    
375   # install an appropriate uvesafb.conf  task_hardware_detection()
376   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  {
377   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die   local message
378    
379   # install an appropriate viafb.conf   run_hardware_detection_disks
  echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die  
380    
381   # install an appropriate i810fb.conf   message+=$"Harddrives:\n"
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die  
382    
383   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   if [[ ! -z ${ALL_DISKS} ]]
384  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd   then
385  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null   for i in ${ALL_DISKS}
386  exit 0   do
387  CHROOTEOF   message+="\Z3${i}\Zn "
388     done
389     message+="\n"
390     fi
391    
392   ## enters chroot   if [[ ! -z ${ALL_CDROMS} ]]
393   mount -t proc proc ${INSTALLROOT}/proc   then
394   mount -t sysfs sysfs ${INSTALLROOT}/sys   message+="\n"
395   mount -o bind /dev ${INSTALLROOT}/dev   message+=$"Optical disk drives:\n"
396   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i   for i in ${ALL_CDROMS}
397   umount ${INSTALLROOT}/proc   do
398   umount ${INSTALLROOT}/sys   message+="\Z3${i}\Zn"
399   umount ${INSTALLROOT}/dev   done
400   rm ${INSTALLROOT}/root/.installrc   message+="\n"
401  }   fi
402    
403  is_uuid_supported()   # other devices
404  {   run_hardware_detection
405   if [[ -x $(type -P busybox.mkinitrd) ]]   case "${SPECIALDEVICE}" in
406     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
407     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
408     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
409     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
410     esac
411     if [[ ${FORMFACTOR} = laptop ]]
412   then   then
413   # only detect uuids if supported   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
  if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]  
  then  
  return 0  
  fi  
414   fi   fi
415    
416   return 1   messagebox -y 12 -h $"Detected hardware:" "${message}"
417  }  }
418    
419  get_uuid()  task_setup_hdd_partitions_manual()
420  {  {
421   local UUID   local i
422   local SEC_TYPE   local retval
  local TYPE  
   
  local dev="$1"  
  [[ -z ${dev} ]] && dialog_die "no dev given"  
423    
424   # check if given device is already an UUID   if [[ -z ${ALL_DISKS} ]]
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
425   then   then
426   eval "${dev}"   dialog_no_harddrive_found
427     exit 1
428   else   else
429   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   HDD=$(dialog_select_target_harddrive)
430     retval=$?
431     [[ ${retval} -eq 1 ]] && return 1
432     if [[ ${retval} -eq 0 ]]
433     then
434     dialog_setup_hdd_info
435     setup_hdd_partitions_manual
436     fi
437   fi   fi
  echo "${UUID}"  
438  }  }
439    
440  install_system_settings()  task_setup_hdd_partitions_auto()
441  {  {
442   # schreibe fstab   local i
443   if is_uuid_supported   local retval
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
   
  # install network config skeleton  
  install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die  
444    
445   # intel framebufer quirk   if [[ -z ${ALL_DISKS} ]]
  if [[ -e /proc/fb ]]  
446   then   then
447   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   dialog_no_harddrive_found
448     exit 1
449     else
450     HDD=$(dialog_select_target_harddrive)
451     retval=$?
452     [[ ${retval} -eq 1 ]] && return 1
453     if [[ ${retval} -eq 0 ]]
454   then   then
455   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   dialog_setup_hdd_info_auto
456   if [[ ${fbdev} != 0 ]]   dialog_setup_hdd_create_partitions
457   then   setup_hdd_partitions_auto
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
458   fi   fi
459   fi   fi
460  }  }
461    
462  install_umount_rootfs()  task_main()
463  {  {
464   cd /   local method=0
465   umount ${INSTALLROOT}/boot || dialog_die   local retval
  umount ${INSTALLROOT} || dialog_die  
 }  
466    
467  install_do_reboot()   while [[ ${method} -le 2 ]]
468  {   do
469   reboot   method=$(dialog_main)
470     retval=$?
471     [[ ${retval} -eq 1 ]] && exit 1
472     if [[ ${retval} -eq 0 ]]
473     then
474     case ${method} in
475     "1") task_setup_system_menu ;;
476     "2") task_hardware_detection ;;
477     "3") install_do_reboot ;;
478     "4") /bin/bash --login -i ;;
479     esac
480     fi
481     done
482  }  }
483    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
   
484  run_install_normal()  run_install_normal()
485  {  {
486   dialog_hardware_detection   task_hardware_detection
487    
488   dialog_setup_hdd_partitions_manuell   task_setup_hdd_partitions_manual
489   dialog_setup_hdd_format   dialog_setup_hdd_format
490   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
491   install_mount_rootfs   mount_rootfs
492   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
493    
494   dialog_install_settings   dialog_install_settings
495   sleep 1   sleep 1
496   install_system_settings   install_system_settings
497   install_initrd_chroot   if is_initrd_supported
498     then
499     dialog_install_initrd
500     initrd_config
501     initrd_install
502     fi
503    
504   dialog_install_bootsector   dialog_install_bootsector
505   install_bootsector_chroot   bootloader_config
506     bootloader_install
507    
508   install_umount_rootfs   umount_rootfs
509   dialog_install_successful   dialog_install_successful
510  }  }
511    
512  run_install_auto()  run_install_auto()
513  {  {
514   dialog_hardware_detection   task_hardware_detection
515    
516   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
517   dialog_setup_hdd_format   dialog_setup_hdd_format
518   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
519   install_mount_rootfs   mount_rootfs
520   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
521    
522   dialog_install_settings   dialog_install_settings
523   sleep 1   sleep 1
524   install_system_settings   install_system_settings
525   install_initrd_chroot   if is_initrd_supported
526     then
527     dialog_install_initrd
528     initrd_config
529     initrd_install
530     fi
531    
532   dialog_install_bootsector   dialog_install_bootsector
533   install_bootsector_chroot   bootloader_config
534     bootloader_install
535    
536   install_umount_rootfs   umount_rootfs
537   dialog_install_successful   dialog_install_successful
538  }  }
539    
540  # set some proper traps  # set some proper traps
541  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
542    
543  dialog_main  task_main
544    
545  exit 0  exit 0

Legend:
Removed from v.2409  
changed lines
  Added in v.2499